 /***************************************************************************
 *  Can bus formed between MCHP Explorere16 with PIC32 Pim and dsPIC Pro 4
 *  Development board
 *  the dsPIC eccepts the message ID 0x200 and diplay the value of a
 *  message counter  on PORTB leds
 *  the dsPIC returns also a counter value to the PIC 32 which diplays
 *  the counter value on PORTA leds
 *  Thus each can node transmit a message and count the message numder and
 *  send it to the second node to siplay the message number
 *  The code demonstrates how to use Message filters and mask.
 *  it also demonstrates  how to transmit and  receive messages
 ****************************************************************************/
#include "built_in.h"
#include "Variables.h"
//---------------------------------------------------------------------------


//--------------------------------------------------------------------------
// function proto type
//--------------------------------------------------------------------------
void Init(void);
void IO_WriteCan(void);
void IO_ReadCan(void);
//--------------------------------------------------------------------------
// Timer 1 Interrupt
//--------------------------------------------------------------------------
void Timer1Int() iv IVT_ADDR_T1INTERRUPT
{
  T1IF_bit = 0;           // Clear T1IF
  LATAbits.LATA6 ^=1;
  Flag.CanTx = TRUE;
  Flag.WriteDisplay = TRUE;
}


//--------------------------------------------------------------------------
// Main Function
//--------------------------------------------------------------------------
void main()
{
 //----------------------------------------
 // Initialize microcontroller
 //----------------------------------------
    Init();

 //---------------------------------------
 // main loop
 //---------------------------------------
  while(1)
  {
    IO_ReadCan();
    IO_WriteCan();
  } //end while(1)
}//end main
//-------------------------------------------------------------------------
void Init()
{
  NSTDIS_bit = 1;             // No nested Interrupts
  TRISAbits.TRISA6 = 0;      // PORTA.B6 as output for led
  TRISAbits.TRISA15 = 0;
  ADPCFG = 0xFFFF;           // Configure AN pins as digital
  TRISB = 0;                // PORTD as output for Led's
  //******************Configure Timer1**************************************
  IPC0  = IPC0 | 0x1000;    // Interrupt priority level = 1
  T1IF_bit = 0;            // Clear T1IF
  T1IE_bit =1;            // Enable Timer1 interrupts
  PR1 = 18500;           // Set Time cycle for CAN Tx
  T1CON = 0x8030;       // Timer1 ON, internal clock FCY, prescaler 1:256

 //-------------------Configure CAN 2 --------------------------------------
  Can_Init_Flags = 0;                              //
  Can_Send_Flags = 0;                              // clear flags
  Can_Rcv_Flags  = 0;                              //

  Can_Send_Flags = _CAN_TX_PRIORITY_0 &            // form value to be used
                   _CAN_TX_STD_FRAME &             // with CAN2Write
                   _CAN_TX_NO_RTR_FRAME;

  Can_Init_Flags = _CAN_CONFIG_SAMPLE_THRICE &     // form value to be used
                   _CAN_CONFIG_PHSEG2_PRG_ON &     // with CAN2Initialize
                   _CAN_CONFIG_STD_MSG &
                   _CAN_CONFIG_DBL_BUFFER_ON &
                   _CAN_CONFIG_MATCH_MSG_TYPE &
                   _CAN_CONFIG_LINE_FILTER_OFF;

  CAN2Initialize(1,2,5,3,1,Can_Init_Flags) ;  //Set baud rate 500Kb/sec
 //CAN1Initialize(1,10,3,3,1,Can_Init_Flags) ; //125Kb/sec @80Mhz
//CAN1Initialize(1,5,4,2,1,Can_Init_Flags) ;  //250Kb/sec @80Mhz

  C2CTRL.CANCKS = 1;  // Set CAN clock to Fcy
  CAN2SetOperationMode(_CAN_MODE_CONFIG,0xFF); // set CONFIGURATION mode
  CAN2SetMask(_CAN_MASK_B1,-1,_CAN_CONFIG_MATCH_MSG_TYPE & _CAN_CONFIG_STD_MSG);
  CAN2SetMask(_CAN_MASK_B2,-1,_CAN_CONFIG_MATCH_MSG_TYPE & _CAN_CONFIG_STD_MSG);
  CAN2SetFilter(_CAN_FILTER_B1_F1,F1,_CAN_CONFIG_STD_MSG);
  CAN2SetFilter(_CAN_FILTER_B1_F2,F2,_CAN_CONFIG_STD_MSG);
  CAN2SetFilter(_CAN_FILTER_B2_F1,F3,_CAN_CONFIG_STD_MSG);
  CAN2SetFilter(_CAN_FILTER_B2_F2,F4,_CAN_CONFIG_STD_MSG);
  CAN2SetFilter(_CAN_FILTER_B2_F3,F5,_CAN_CONFIG_STD_MSG);
  CAN2SetFilter(_CAN_FILTER_B2_F4,F6,_CAN_CONFIG_STD_MSG);
  CAN2SetOperationMode(_CAN_MODE_NORMAL,0xFF);//set normal mode
  Msg_Rcvd = 0;

}
//--------------------------------------------------------------------------
void IO_WriteCan()
{
if(Flag.CanTx)
   {
     static unsigned char counter ;
      counter++;
      Tx_Data[0] = 0xFC;
      Tx_Data[1] = counter;
      Tx_Data[2] = 0;
      Tx_Data[3] = 0;
      Tx_Data[4] = 0;
      Tx_Data[5] = 0;
      Tx_Data[6] = 0xFB;
      Tx_Data[7] = counter;
      Tx_Data_Len = 8;
      Tx_ID = 0x200;
      CAN2Write(Tx_ID, Tx_Data, Tx_Data_Len, Can_Send_Flags);
      Flag.CanTx = FALSE ;
    }
}
//-------------------------------------------------------------------------
void IO_ReadCan()
{
   // read the incomeing messages
  Msg_Rcvd = CAN2Read(&RxID ,Rx_Data ,&Rx_Data_Len,&Can_Rcv_Flags);
  if (Msg_Rcvd )
  {
    switch (RxID)
   {
     case  0x200 :
      asm nop ;
      break;
     case 0x211 :
          LATB = Rx_Data[2]; // extract the data in the message
      break;
     case 0x300 :
      asm nop;
     break;
     case 0x310 :
      asm nop;
     break;
   }// end switch case
   Msg_Rcvd = 0;
  }
}
//*********************************EOF****************************************